install.sh 16 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510
  1. #!/bin/sh
  2. #
  3. # This script should be run via curl:
  4. # sh -c "$(curl -fsSL https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh)"
  5. # or via wget:
  6. # sh -c "$(wget -qO- https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh)"
  7. # or via fetch:
  8. # sh -c "$(fetch -o - https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh)"
  9. #
  10. # As an alternative, you can first download the install script and run it afterwards:
  11. # wget https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh
  12. # sh install.sh
  13. #
  14. # You can tweak the install behavior by setting variables when running the script. For
  15. # example, to change the path to the Oh My Zsh repository:
  16. # ZSH=~/.zsh sh install.sh
  17. #
  18. # Respects the following environment variables:
  19. # ZSH - path to the Oh My Zsh repository folder (default: $HOME/.oh-my-zsh)
  20. # REPO - name of the GitHub repo to install from (default: ohmyzsh/ohmyzsh)
  21. # REMOTE - full remote URL of the git repo to install (default: GitHub via HTTPS)
  22. # BRANCH - branch to check out immediately after install (default: master)
  23. #
  24. # Other options:
  25. # CHSH - 'no' means the installer will not change the default shell (default: yes)
  26. # RUNZSH - 'no' means the installer will not run zsh after the install (default: yes)
  27. # KEEP_ZSHRC - 'yes' means the installer will not replace an existing .zshrc (default: no)
  28. #
  29. # You can also pass some arguments to the install script to set some these options:
  30. # --skip-chsh: has the same behavior as setting CHSH to 'no'
  31. # --unattended: sets both CHSH and RUNZSH to 'no'
  32. # --keep-zshrc: sets KEEP_ZSHRC to 'yes'
  33. # For example:
  34. # sh install.sh --unattended
  35. # or:
  36. # sh -c "$(curl -fsSL https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh)" "" --unattended
  37. #
  38. set -e
  39. # Make sure important variables exist if not already defined
  40. #
  41. # $USER is defined by login(1) which is not always executed (e.g. containers)
  42. # POSIX: https://pubs.opengroup.org/onlinepubs/009695299/utilities/id.html
  43. USER=${USER:-$(id -u -n)}
  44. # $HOME is defined at the time of login, but it could be unset. If it is unset,
  45. # a tilde by itself (~) will not be expanded to the current user's home directory.
  46. # POSIX: https://pubs.opengroup.org/onlinepubs/009696899/basedefs/xbd_chap08.html#tag_08_03
  47. HOME="${HOME:-$(getent passwd $USER | cut -d: -f6)}"
  48. # Track if $ZSH was provided
  49. custom_zsh=${ZSH:+yes}
  50. # Default settings
  51. ZSH="${ZSH:-$HOME/.oh-my-zsh}"
  52. REPO=${REPO:-ohmyzsh/ohmyzsh}
  53. REMOTE=${REMOTE:-https://github.com/${REPO}.git}
  54. BRANCH=${BRANCH:-master}
  55. # Other options
  56. CHSH=${CHSH:-yes}
  57. RUNZSH=${RUNZSH:-yes}
  58. KEEP_ZSHRC=${KEEP_ZSHRC:-no}
  59. command_exists() {
  60. command -v "$@" >/dev/null 2>&1
  61. }
  62. user_can_sudo() {
  63. # Check if sudo is installed
  64. command_exists sudo || return 1
  65. # The following command has 3 parts:
  66. #
  67. # 1. Run `sudo` with `-v`. Does the following:
  68. # • with privilege: asks for a password immediately.
  69. # • without privilege: exits with error code 1 and prints the message:
  70. # Sorry, user <username> may not run sudo on <hostname>
  71. #
  72. # 2. Pass `-n` to `sudo` to tell it to not ask for a password. If the
  73. # password is not required, the command will finish with exit code 0.
  74. # If one is required, sudo will exit with error code 1 and print the
  75. # message:
  76. # sudo: a password is required
  77. #
  78. # 3. Check for the words "may not run sudo" in the output to really tell
  79. # whether the user has privileges or not. For that we have to make sure
  80. # to run `sudo` in the default locale (with `LANG=`) so that the message
  81. # stays consistent regardless of the user's locale.
  82. #
  83. ! LANG= sudo -n -v 2>&1 | grep -q "may not run sudo"
  84. }
  85. # The [ -t 1 ] check only works when the function is not called from
  86. # a subshell (like in `$(...)` or `(...)`, so this hack redefines the
  87. # function at the top level to always return false when stdout is not
  88. # a tty.
  89. if [ -t 1 ]; then
  90. is_tty() {
  91. true
  92. }
  93. else
  94. is_tty() {
  95. false
  96. }
  97. fi
  98. # This function uses the logic from supports-hyperlinks[1][2], which is
  99. # made by Kat Marchán (@zkat) and licensed under the Apache License 2.0.
  100. # [1] https://github.com/zkat/supports-hyperlinks
  101. # [2] https://crates.io/crates/supports-hyperlinks
  102. #
  103. # Copyright (c) 2021 Kat Marchán
  104. #
  105. # Licensed under the Apache License, Version 2.0 (the "License");
  106. # you may not use this file except in compliance with the License.
  107. # You may obtain a copy of the License at
  108. #
  109. # http://www.apache.org/licenses/LICENSE-2.0
  110. #
  111. # Unless required by applicable law or agreed to in writing, software
  112. # distributed under the License is distributed on an "AS IS" BASIS,
  113. # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  114. # See the License for the specific language governing permissions and
  115. # limitations under the License.
  116. supports_hyperlinks() {
  117. # $FORCE_HYPERLINK must be set and be non-zero (this acts as a logic bypass)
  118. if [ -n "$FORCE_HYPERLINK" ]; then
  119. [ "$FORCE_HYPERLINK" != 0 ]
  120. return $?
  121. fi
  122. # If stdout is not a tty, it doesn't support hyperlinks
  123. is_tty || return 1
  124. # DomTerm terminal emulator (domterm.org)
  125. if [ -n "$DOMTERM" ]; then
  126. return 0
  127. fi
  128. # VTE-based terminals above v0.50 (Gnome Terminal, Guake, ROXTerm, etc)
  129. if [ -n "$VTE_VERSION" ]; then
  130. [ $VTE_VERSION -ge 5000 ]
  131. return $?
  132. fi
  133. # If $TERM_PROGRAM is set, these terminals support hyperlinks
  134. case "$TERM_PROGRAM" in
  135. Hyper|iTerm.app|terminology|WezTerm) return 0 ;;
  136. esac
  137. # kitty supports hyperlinks
  138. if [ "$TERM" = xterm-kitty ]; then
  139. return 0
  140. fi
  141. # Windows Terminal or Konsole also support hyperlinks
  142. if [ -n "$WT_SESSION" ] || [ -n "$KONSOLE_VERSION" ]; then
  143. return 0
  144. fi
  145. return 1
  146. }
  147. # Adapted from code and information by Anton Kochkov (@XVilka)
  148. # Source: https://gist.github.com/XVilka/8346728
  149. supports_truecolor() {
  150. case "$COLORTERM" in
  151. truecolor|24bit) return 0 ;;
  152. esac
  153. case "$TERM" in
  154. iterm |\
  155. tmux-truecolor |\
  156. linux-truecolor |\
  157. xterm-truecolor |\
  158. screen-truecolor) return 0 ;;
  159. esac
  160. return 1
  161. }
  162. fmt_link() {
  163. # $1: text, $2: url, $3: fallback mode
  164. if supports_hyperlinks; then
  165. printf '\033]8;;%s\a%s\033]8;;\a\n' "$2" "$1"
  166. return
  167. fi
  168. case "$3" in
  169. --text) printf '%s\n' "$1" ;;
  170. --url|*) fmt_underline "$2" ;;
  171. esac
  172. }
  173. fmt_underline() {
  174. is_tty && printf '\033[4m%s\033[24m\n' "$*" || printf '%s\n' "$*"
  175. }
  176. # shellcheck disable=SC2016 # backtick in single-quote
  177. fmt_code() {
  178. is_tty && printf '`\033[2m%s\033[22m`\n' "$*" || printf '`%s`\n' "$*"
  179. }
  180. fmt_error() {
  181. printf '%sError: %s%s\n' "${FMT_BOLD}${FMT_RED}" "$*" "$FMT_RESET" >&2
  182. }
  183. setup_color() {
  184. # Only use colors if connected to a terminal
  185. if ! is_tty; then
  186. FMT_RAINBOW=""
  187. FMT_RED=""
  188. FMT_GREEN=""
  189. FMT_YELLOW=""
  190. FMT_BLUE=""
  191. FMT_BOLD=""
  192. FMT_RESET=""
  193. return
  194. fi
  195. if supports_truecolor; then
  196. FMT_RAINBOW="
  197. $(printf '\033[38;2;255;0;0m')
  198. $(printf '\033[38;2;255;97;0m')
  199. $(printf '\033[38;2;247;255;0m')
  200. $(printf '\033[38;2;0;255;30m')
  201. $(printf '\033[38;2;77;0;255m')
  202. $(printf '\033[38;2;168;0;255m')
  203. $(printf '\033[38;2;245;0;172m')
  204. "
  205. else
  206. FMT_RAINBOW="
  207. $(printf '\033[38;5;196m')
  208. $(printf '\033[38;5;202m')
  209. $(printf '\033[38;5;226m')
  210. $(printf '\033[38;5;082m')
  211. $(printf '\033[38;5;021m')
  212. $(printf '\033[38;5;093m')
  213. $(printf '\033[38;5;163m')
  214. "
  215. fi
  216. FMT_RED=$(printf '\033[31m')
  217. FMT_GREEN=$(printf '\033[32m')
  218. FMT_YELLOW=$(printf '\033[33m')
  219. FMT_BLUE=$(printf '\033[34m')
  220. FMT_BOLD=$(printf '\033[1m')
  221. FMT_RESET=$(printf '\033[0m')
  222. }
  223. setup_ohmyzsh() {
  224. # Prevent the cloned repository from having insecure permissions. Failing to do
  225. # so causes compinit() calls to fail with "command not found: compdef" errors
  226. # for users with insecure umasks (e.g., "002", allowing group writability). Note
  227. # that this will be ignored under Cygwin by default, as Windows ACLs take
  228. # precedence over umasks except for filesystems mounted with option "noacl".
  229. umask g-w,o-w
  230. echo "${FMT_BLUE}Cloning Oh My Zsh...${FMT_RESET}"
  231. command_exists git || {
  232. fmt_error "git is not installed"
  233. exit 1
  234. }
  235. ostype=$(uname)
  236. if [ -z "${ostype%CYGWIN*}" ] && git --version | grep -q msysgit; then
  237. fmt_error "Windows/MSYS Git is not supported on Cygwin"
  238. fmt_error "Make sure the Cygwin git package is installed and is first on the \$PATH"
  239. exit 1
  240. fi
  241. # Manual clone with git config options to support git < v1.7.2
  242. git init "$ZSH" && cd "$ZSH" \
  243. && git config core.eol lf \
  244. && git config core.autocrlf false \
  245. && git config fsck.zeroPaddedFilemode ignore \
  246. && git config fetch.fsck.zeroPaddedFilemode ignore \
  247. && git config receive.fsck.zeroPaddedFilemode ignore \
  248. && git config oh-my-zsh.remote origin \
  249. && git config oh-my-zsh.branch "$BRANCH" \
  250. && git remote add origin "$REMOTE" \
  251. && git fetch --depth=1 origin \
  252. && git checkout -b "$BRANCH" "origin/$BRANCH" || {
  253. rm -rf "$ZSH"
  254. fmt_error "git clone of oh-my-zsh repo failed"
  255. exit 1
  256. }
  257. echo
  258. }
  259. setup_zshrc() {
  260. # Keep most recent old .zshrc at .zshrc.pre-oh-my-zsh, and older ones
  261. # with datestamp of installation that moved them aside, so we never actually
  262. # destroy a user's original zshrc
  263. echo "${FMT_BLUE}Looking for an existing zsh config...${FMT_RESET}"
  264. # Must use this exact name so uninstall.sh can find it
  265. OLD_ZSHRC=~/.zshrc.pre-oh-my-zsh
  266. if [ -f ~/.zshrc ] || [ -h ~/.zshrc ]; then
  267. # Skip this if the user doesn't want to replace an existing .zshrc
  268. if [ "$KEEP_ZSHRC" = yes ]; then
  269. echo "${FMT_YELLOW}Found ~/.zshrc.${FMT_RESET} ${FMT_GREEN}Keeping...${FMT_RESET}"
  270. return
  271. fi
  272. if [ -e "$OLD_ZSHRC" ]; then
  273. OLD_OLD_ZSHRC="${OLD_ZSHRC}-$(date +%Y-%m-%d_%H-%M-%S)"
  274. if [ -e "$OLD_OLD_ZSHRC" ]; then
  275. fmt_error "$OLD_OLD_ZSHRC exists. Can't back up ${OLD_ZSHRC}"
  276. fmt_error "re-run the installer again in a couple of seconds"
  277. exit 1
  278. fi
  279. mv "$OLD_ZSHRC" "${OLD_OLD_ZSHRC}"
  280. echo "${FMT_YELLOW}Found old ~/.zshrc.pre-oh-my-zsh." \
  281. "${FMT_GREEN}Backing up to ${OLD_OLD_ZSHRC}${FMT_RESET}"
  282. fi
  283. echo "${FMT_YELLOW}Found ~/.zshrc.${FMT_RESET} ${FMT_GREEN}Backing up to ${OLD_ZSHRC}${FMT_RESET}"
  284. mv ~/.zshrc "$OLD_ZSHRC"
  285. fi
  286. echo "${FMT_GREEN}Using the Oh My Zsh template file and adding it to ~/.zshrc.${FMT_RESET}"
  287. # Replace $HOME path with '$HOME' in $ZSH variable in .zshrc file
  288. omz=$(echo "$ZSH" | sed "s|^$HOME/|\$HOME/|")
  289. sed "s|^export ZSH=.*$|export ZSH=\"${omz}\"|" "$ZSH/templates/zshrc.zsh-template" > ~/.zshrc-omztemp
  290. mv -f ~/.zshrc-omztemp ~/.zshrc
  291. echo
  292. }
  293. setup_shell() {
  294. # Skip setup if the user wants or stdin is closed (not running interactively).
  295. if [ "$CHSH" = no ]; then
  296. return
  297. fi
  298. # If this user's login shell is already "zsh", do not attempt to switch.
  299. if [ "$(basename -- "$SHELL")" = "zsh" ]; then
  300. return
  301. fi
  302. # If this platform doesn't provide a "chsh" command, bail out.
  303. if ! command_exists chsh; then
  304. cat <<EOF
  305. I can't change your shell automatically because this system does not have chsh.
  306. ${FMT_BLUE}Please manually change your default shell to zsh${FMT_RESET}
  307. EOF
  308. return
  309. fi
  310. echo "${FMT_BLUE}Time to change your default shell to zsh:${FMT_RESET}"
  311. # Prompt for user choice on changing the default login shell
  312. printf '%sDo you want to change your default shell to zsh? [Y/n]%s ' \
  313. "$FMT_YELLOW" "$FMT_RESET"
  314. read -r opt
  315. case $opt in
  316. y*|Y*|"") ;;
  317. n*|N*) echo "Shell change skipped."; return ;;
  318. *) echo "Invalid choice. Shell change skipped."; return ;;
  319. esac
  320. # Check if we're running on Termux
  321. case "$PREFIX" in
  322. *com.termux*) termux=true; zsh=zsh ;;
  323. *) termux=false ;;
  324. esac
  325. if [ "$termux" != true ]; then
  326. # Test for the right location of the "shells" file
  327. if [ -f /etc/shells ]; then
  328. shells_file=/etc/shells
  329. elif [ -f /usr/share/defaults/etc/shells ]; then # Solus OS
  330. shells_file=/usr/share/defaults/etc/shells
  331. else
  332. fmt_error "could not find /etc/shells file. Change your default shell manually."
  333. return
  334. fi
  335. # Get the path to the right zsh binary
  336. # 1. Use the most preceding one based on $PATH, then check that it's in the shells file
  337. # 2. If that fails, get a zsh path from the shells file, then check it actually exists
  338. if ! zsh=$(command -v zsh) || ! grep -qx "$zsh" "$shells_file"; then
  339. if ! zsh=$(grep '^/.*/zsh$' "$shells_file" | tail -n 1) || [ ! -f "$zsh" ]; then
  340. fmt_error "no zsh binary found or not present in '$shells_file'"
  341. fmt_error "change your default shell manually."
  342. return
  343. fi
  344. fi
  345. fi
  346. # We're going to change the default shell, so back up the current one
  347. if [ -n "$SHELL" ]; then
  348. echo "$SHELL" > ~/.shell.pre-oh-my-zsh
  349. else
  350. grep "^$USER:" /etc/passwd | awk -F: '{print $7}' > ~/.shell.pre-oh-my-zsh
  351. fi
  352. echo "Changing your shell to $zsh..."
  353. # Check if user has sudo privileges to run `chsh` with or without `sudo`
  354. #
  355. # This allows the call to succeed without password on systems where the
  356. # user does not have a password but does have sudo privileges, like in
  357. # Google Cloud Shell.
  358. #
  359. # On systems that don't have a user with passwordless sudo, the user will
  360. # be prompted for the password either way, so this shouldn't cause any issues.
  361. #
  362. if user_can_sudo; then
  363. sudo -k chsh -s "$zsh" "$USER" # -k forces the password prompt
  364. else
  365. chsh -s "$zsh" "$USER" # run chsh normally
  366. fi
  367. # Check if the shell change was successful
  368. if [ $? -ne 0 ]; then
  369. fmt_error "chsh command unsuccessful. Change your default shell manually."
  370. else
  371. export SHELL="$zsh"
  372. echo "${FMT_GREEN}Shell successfully changed to '$zsh'.${FMT_RESET}"
  373. fi
  374. echo
  375. }
  376. # shellcheck disable=SC2183 # printf string has more %s than arguments ($FMT_RAINBOW expands to multiple arguments)
  377. print_success() {
  378. printf '%s %s__ %s %s %s %s %s__ %s\n' $FMT_RAINBOW $FMT_RESET
  379. printf '%s ____ %s/ /_ %s ____ ___ %s__ __ %s ____ %s_____%s/ /_ %s\n' $FMT_RAINBOW $FMT_RESET
  380. printf '%s / __ \\%s/ __ \\ %s / __ `__ \\%s/ / / / %s /_ / %s/ ___/%s __ \\ %s\n' $FMT_RAINBOW $FMT_RESET
  381. printf '%s/ /_/ /%s / / / %s / / / / / /%s /_/ / %s / /_%s(__ )%s / / / %s\n' $FMT_RAINBOW $FMT_RESET
  382. printf '%s\\____/%s_/ /_/ %s /_/ /_/ /_/%s\\__, / %s /___/%s____/%s_/ /_/ %s\n' $FMT_RAINBOW $FMT_RESET
  383. printf '%s %s %s %s /____/ %s %s %s %s....is now installed!%s\n' $FMT_RAINBOW $FMT_GREEN $FMT_RESET
  384. printf '\n'
  385. printf '\n'
  386. printf "%s %s %s\n" "Before you scream ${FMT_BOLD}${FMT_YELLOW}Oh My Zsh!${FMT_RESET} look over the" \
  387. "$(fmt_code "$(fmt_link ".zshrc" "file://$HOME/.zshrc" --text)")" \
  388. "file to select plugins, themes, and options."
  389. printf '\n'
  390. printf '%s\n' "• Follow us on Twitter: $(fmt_link @ohmyzsh https://twitter.com/ohmyzsh)"
  391. printf '%s\n' "• Join our Discord community: $(fmt_link "Discord server" https://discord.gg/ohmyzsh)"
  392. printf '%s\n' "• Get stickers, t-shirts, coffee mugs and more: $(fmt_link "Planet Argon Shop" https://shop.planetargon.com/collections/oh-my-zsh)"
  393. printf '%s\n' $FMT_RESET
  394. }
  395. main() {
  396. # Run as unattended if stdin is not a tty
  397. if [ ! -t 0 ]; then
  398. RUNZSH=no
  399. CHSH=no
  400. fi
  401. # Parse arguments
  402. while [ $# -gt 0 ]; do
  403. case $1 in
  404. --unattended) RUNZSH=no; CHSH=no ;;
  405. --skip-chsh) CHSH=no ;;
  406. --keep-zshrc) KEEP_ZSHRC=yes ;;
  407. esac
  408. shift
  409. done
  410. setup_color
  411. if ! command_exists zsh; then
  412. echo "${FMT_YELLOW}Zsh is not installed.${FMT_RESET} Please install zsh first."
  413. exit 1
  414. fi
  415. if [ -d "$ZSH" ]; then
  416. echo "${FMT_YELLOW}The \$ZSH folder already exists ($ZSH).${FMT_RESET}"
  417. if [ "$custom_zsh" = yes ]; then
  418. cat <<EOF
  419. You ran the installer with the \$ZSH setting or the \$ZSH variable is
  420. exported. You have 3 options:
  421. 1. Unset the ZSH variable when calling the installer:
  422. $(fmt_code "ZSH= sh install.sh")
  423. 2. Install Oh My Zsh to a directory that doesn't exist yet:
  424. $(fmt_code "ZSH=path/to/new/ohmyzsh/folder sh install.sh")
  425. 3. (Caution) If the folder doesn't contain important information,
  426. you can just remove it with $(fmt_code "rm -r $ZSH")
  427. EOF
  428. else
  429. echo "You'll need to remove it if you want to reinstall."
  430. fi
  431. exit 1
  432. fi
  433. setup_ohmyzsh
  434. setup_zshrc
  435. setup_shell
  436. print_success
  437. if [ $RUNZSH = no ]; then
  438. echo "${FMT_YELLOW}Run zsh to try it out.${FMT_RESET}"
  439. exit
  440. fi
  441. exec zsh -l
  442. }
  443. main "$@"